net.sourceforge.jnlp.cache

## Interface DownloadIndicator

- All Known Implementing Classes:
    DefaultDownloadIndicator

      public interface DownloadIndicator

  A DownloadIndicator creates DownloadServiceListeners that are notified of resources being transferred and their progress.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `disposeListener(DownloadServiceListener listener)` Indicates that a download service listener that was obtained from the getDownloadListener method will no longer be used.
    `int` | `getInitialDelay()` Return a time in milliseconds to wait for a download to complete before obtaining a listener for the download.
    `DownloadServiceListener` | `getListener(ApplicationInstance app, java.lang.String downloadName, java.net.URL[] resources)` Return a download service listener that displays the progress of downloading resources.
    `int` | `getUpdateRate()` Return the desired time in milliseconds between updates.

- - ### Method Detail

    - #### getListener

          DownloadServiceListener getListener(ApplicationInstance app,
                                              java.lang.String downloadName,
                                              java.net.URL[] resources)

      Return a download service listener that displays the progress of downloading resources. Update messages may be reported for URLs that are not included initially.

      Progress messages are sent as if the DownloadServiceListener were listening to a DownloadService request. The listener will receive progress messages from time to time during the download.

      Parameters:
        `app` - JNLP application downloading the files, or null if not applicable
        `downloadName` - name identifying the download to the user
        `resources` - initial urls to display, empty if none known at start
      Returns:
        dedicated listener

    - #### disposeListener

          void disposeListener(DownloadServiceListener listener)

      Indicates that a download service listener that was obtained from the getDownloadListener method will no longer be used. This method can be used to ensure that progress dialogs are properly removed once a particular download is finished.
      Parameters:
        `listener` - the listener that is no longer in use

    - #### getUpdateRate

          int getUpdateRate()

      Return the desired time in milliseconds between updates. Updates are not guarenteed to occur based on this value; for example, they may occur based on the download percent or some other factor.
      Returns:
        rate in milliseconds, must be >= 0

    - #### getInitialDelay

          int getInitialDelay()

      Return a time in milliseconds to wait for a download to complete before obtaining a listener for the download. This value can be used to skip lengthy operations, such as initializing a GUI, for downloads that complete quickly. The getListener method is not called if the download completes in less time than the returned delay.
      Returns:
        delay in milliseconds, must be >= 0

Submit a bug or feature